// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, SparqlConnection};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "TrackerEndpoint")]
    pub struct Endpoint(Object<ffi::TrackerEndpoint, ffi::TrackerEndpointClass>);

    match fn {
        type_ => || ffi::tracker_endpoint_get_type(),
    }
}

impl Endpoint {
    pub const NONE: Option<&'static Endpoint> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Endpoint>> Sealed for T {}
}

pub trait EndpointExt: IsA<Endpoint> + sealed::Sealed + 'static {
    #[doc(alias = "tracker_endpoint_get_sparql_connection")]
    #[doc(alias = "get_sparql_connection")]
    #[doc(alias = "sparql-connection")]
    fn sparql_connection(&self) -> Option<SparqlConnection> {
        unsafe {
            from_glib_none(ffi::tracker_endpoint_get_sparql_connection(
                self.as_ref().to_glib_none().0,
            ))
        }
    }
}

impl<O: IsA<Endpoint>> EndpointExt for O {}
